//============================================================================
// 633 WinTest Code.
// show_packet,cpp: Ultra-simple 633 command-line communications example
// Copyright 2001, Crystalfontz America, Inc. Written by Brent A. Crosby
// www.crystalfontz.com, brent@crystalfontz.com
//============================================================================
#include <stdio.h>
#include <netinet/in.h>
#include "typedefs.h"
#include "633_packet.h"
#include "show_packet.h"
//============================================================================
float temps[32][5]={0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
                   0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
                   0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
                   0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
                   0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
                   0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
                   0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
                   0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
                   0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
                   0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0};
int history=0;
const char
 *command_names[31]=
   {" 0 = Ping",
    " 1 = Read Version",
    " 2 = Write Flash",
    " 3 = Read Flash",
    " 4 = Store Boot State",
    " 5 = Reboot",
    " 6 = Clear LCD",
    " 7 = LCD Line 1",
    " 8 = LCD Line 2",
    " 9 = LCD CGRAM",
    "10 = Read LCD Memory",
    "11 = Place Cursor",
    "12 = Set Cursor Style",
    "13 = Contrast",
    "14 = Backlight",
    "15 = Read Fans",
    "16 = Set Fan Rpt.",
    "17 = Set Fan Power",
    "18 = Read DOW ID",
    "19 = Set Temp. Rpt",
    "20 = DOW Transaction",
    "21 = Set Live Display",
    "22 = Direct LCD Command",
    "23 = Set Key Event Reporting",
    "24 = Read Keypad, Polled Mode",
    "25 = Set Fan Fail-Safe",
    "26 = Set Fan RPM Glitch Filter",
    "27 = Read Fan Pwr & Fail-Safe",
    "28 = Set ATX switch functionality",
    "29 = Watchdog Host Reset",
    "30 = Rd Rpt"};
const char
	*error_names[31]=
   {"Error: Ping",
    "Error: Version",
    "Error: Write Flash",
    "Error: Read Flash",
    "Error: Store Boot State",
    "Error: Reboot",
    "Error: Clear LCD",
    "Error: Set LCD 1",
    "Error: Set LCD 2",
    "Error: Set LCD CGRAM",
    "Error: Read LCD Memory",
    "Error: Place LCD Cursor",
    "Error: LCD Cursor Style",
    "Error: Contrast",
    "Error: Backlight",
    "Error: Query Fan",
    "Error: Set Fan Rept.",
    "Error: Set Fan Power",
    "Error: Read DOW ID",
    "Error: Set Temp. Rept.",
    "Error: DOW Transaction",
    "Error: Setup Live Disp",
    "Error: Direct LCD Command",
    "Error: Set Key Event Reporting",
    "Error: Read Keypad, Polled Mode",
    "Error: Set Fan Fail-Safe",
    "Error: Set Fan RPM Glitch Filter",
    "Error: Read Fan Pwr & Fail-Safe",
    "Error: Set ATX switch functionality",
    "Error: Watchdog Host Reset",
    "Error: Read  Reporting/ATX/Watchdog"};
const char
	*key_names[13]=
   {"KEY_NONE",
    "KEY_UP_PRESS",
    "KEY_DOWN_PRESS",
    "KEY_LEFT_PRESS",
    "KEY_RIGHT_PRESS",
    "KEY_ENTER_PRESS",
    "KEY_EXIT_PRESS",
    "KEY_UP_RELEASE",
    "KEY_DOWN_RELEASE",
    "KEY_LEFT_RELEASE",
    "KEY_RIGHT_RELEASE",
    "KEY_ENTER_RELEASE",
    "KEY_EXIT_RELEASE"};
//----------------------------------------------------------------------------
void ShowReceivedPacket(void) 
  {
  int
    i;
  //Terminate the incoming data so C handles it well in case it is a string.
  incoming_command.data[incoming_command.data_length]=0;
  char
    expanded[400];
  expanded[0]=0;
  for(i=0;i<incoming_command.data_length;i++)
    {
    if(isprint(incoming_command.data[i]))
      {
      int
        current_length=strlen(expanded);
      expanded[current_length]=incoming_command.data[i];
      expanded[current_length+1]=0;
      }
    else
      {
      char
        bin_number[5];
      sprintf(bin_number,"\\%03d",incoming_command.data[i]);
			strcat(expanded,bin_number);
      }
    }

  //key
  if(incoming_command.command==0x80)
    printf("this is the 0x80 C=%d(key:%s),L=%d,D=\"%s\",CRC=0x%04X\n",
      incoming_command.command,
      incoming_command.data[0]<=12?
        key_names[incoming_command.data[0]]:
        "HUH?",
      incoming_command.data_length,
      expanded,
      incoming_command.CRC);

  else    if  ( incoming_command.command == 82) { 
	unsigned char t[9]={0,0,0,0,0,0,0,0,0};
	unsigned char counter, place, in_val, out_val, val;
/* print raw  was counter=0; counter <9 */
	for (counter=0; counter <5; counter++) { t[counter]=incoming_command.data[counter]; }
	printf(" %02d   %02X  %02X  %02X :", t[0], t[2], t[3], t[4] );

	for (counter=2; counter <5; counter++) {
	unsigned char d[9]={0,0,0,0,0,0,0,0,0};
		in_val=128;
		unsigned char bitwise=0;
		out_val=1;
		d[counter]=0;
		bitwise = ((128&t[counter])>>7)+((64&t[counter])>>5)+((32&t[counter])>>3)+((16&t[counter])>>1)
			+((8&t[counter])<<1)+((4&t[counter])<<3)+((2&t[counter])<<5)+((1&t[counter])<<7);
		for (place=0; place <8; place++){
			if (t[counter]>=in_val) val=1; else val=0;
			d[counter]+=val*out_val;
			t[counter]-=val*in_val;
			in_val=in_val/2;
			out_val=out_val*2;
			}
		printf(" %02x ", bitwise);
	}
	printf("\n");
  }
  else	if ( incoming_command.command == 130) {
            if (incoming_command.data[0]==0) {
		    history++;
		    if (history==5) history=0;
		    printf("\n");
	    }
	    temps[incoming_command.data[0]][history]=
		    (float)(*((short *)(&incoming_command.data[1]))) /16;
	if ( (temps[incoming_command.data[0]][0] +  temps[incoming_command.data[0]][1] +
			 temps[incoming_command.data[0]][2] +  temps[incoming_command.data[0]][3] +
			  temps[incoming_command.data[0]][4]) / 5  <  temps [incoming_command.data[0]][history] -.04) 
		printf ("%2d ", incoming_command.data[0]); 
	else if ( (temps[incoming_command.data[0]][0] +  temps[incoming_command.data[0]][1] +
			 temps[incoming_command.data[0]][2] +  temps[incoming_command.data[0]][3] +
			  temps[incoming_command.data[0]][4]) / 5  >  temps [incoming_command.data[0]][history] +.04) 
		printf ("-- "); 
	else printf ("   ");

	    
//            printf("%2.4f ", (float)(*((short *)(&incoming_command.data[1]))) /16);
	}    
  else {  
        printf("C=%d(%s),L=%d,D=\"%s\",CRC=0x%04X\n",
	        incoming_command.command,
	      ((incoming_command.command&0xC0)==0xC0)?
                 error_names[0x3F&incoming_command.command]:
              command_names[0x3F&incoming_command.command],
                  incoming_command.data_length,
	            expanded,
                   incoming_command.CRC);
  }
  }
//============================================================================
