// 633_COMMAND_LINE_TEST.cpp
// Ultra-simple 633 command-line communications example

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include "typedefs.h"
#include "serial.h"
#include "633_packet.h"
#include "show_packet.h"

//com port. 0=COM1 or ttyS0
#define COMPORT 1
//baud rate
#define BAUD 19200


//============================================================================
int main(int argc, char* argv[])
{
	printf("Ultra-simple 633 command-line communications example.\n");
	printf("Crystalfotnz America, Inc. http://www.crystalfontz.com\n\n");
	printf("          633-port-IDS modification by annonymous_putterer\n\n");

	if(Serial_Init(COMPORT, BAUD) != 0)
	{
 		printf("Could not open com port.\n");
		return 1;
	}

// stop auto temp reports   
outgoing_response.data_length=4;
outgoing_response.command=19;
outgoing_response.data[0]=0 ;
outgoing_response.data[1]=0 ;
outgoing_response.data[2]=0 ;
outgoing_response.data[3]=0 ;
send_packet();
	check_for_packet(0); 

sleep(2);

unsigned char sense_enable_mask[4]={0,0,0,0};
unsigned char sensor_mask_thingy=1;

printf ("      wintest      bitflipped\n");
printf ("  #   ID  ID  ID   ID  ID  ID\n");

char line;
for (line=0; line < 32; line++) {
	outgoing_response.data_length=1;
	outgoing_response.command=18;
	outgoing_response.data[0]=line ;
	send_packet();
	usleep( 20000);
	if (check_for_packet(0)) 
		ShowReceivedPacket();
        if (incoming_command.data[1]!=0) sense_enable_mask[(int)(line/8)]+= sensor_mask_thingy ;
        if (sensor_mask_thingy == 128 ) sensor_mask_thingy=1;
		else sensor_mask_thingy*=2;
			

}


sleep(1);
// initiate auto temp reports   
outgoing_response.data_length=4;
outgoing_response.command=19;
outgoing_response.data[0]=sense_enable_mask[0] ;
outgoing_response.data[1]=sense_enable_mask[1] ;
outgoing_response.data[2]=sense_enable_mask[2] ;
outgoing_response.data[3]=sense_enable_mask[3] ;
send_packet();

while(1)
  {
    if(check_for_packet(0))
      ShowReceivedPacket();
    }

  Uninit_Serial();
  return 0;
  }
//============================================================================
